#include"io430.h"
#define uchar unsigned char
#define uint unsigned int
#define ulong unsigned long
#define CLK0  P1OUT&=~BIT6
#define CLK1   P1OUT|=BIT6
#define CPU_F ((double)1000000)   //ⲿƵ16MHZ
//#define CPU_F ((double)32768)   //ⲿƵ32.768KHZ
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0)) 
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0)) 


unsigned char const code_hex[]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x6f,0x39,0x79,0x0e,0x3e,0x00};//0,1,2,3,4,5,6,7,8,9,c,e,j,u, ,
uchar t,t1,t2,t3;
uchar dis_play[4]; 


//ʾ

void extern_16m()
{
  WDTCTL = WDTPW + WDTHOLD;
    if (CALBC1_1MHZ == 0xFF || CALDCO_1MHZ == 0xFF)
        {
                while(1);                // If calibration constants erased, trap CPU!!
        }
 DCOCTL |= DCO0 + DCO1+DCO2;                                                                   //SMCLKѡLFXT1CLK
// BCSCTL2 |= SELM_0;//MCLK1MڲDCO    
// BCSCTL2 |= DIVS_0;//SMCLKڲʱ 


}

void hc164_init()
{
  P1DIR |=BIT6+BIT7+BIT0+BIT1+BIT2+BIT3;                            // P1.0 output
  
}

void sendbyte(uchar byte) 
{            
uchar c,num;   
num=byte;
for(c=0;c<8;c++)        
{     
 P1OUT&=~0x80;
 CLK0;    
 P1OUT|=num&0x80; //(0x80ʮƵ128, Ƶ10000000 λ 
 CLK1;         
num<<=1;    
} 
} 


void send_char(uchar weizhi,uchar byte)
{
  
  P1OUT |= 0x0f;   
  uchar c,send_byte; 
  send_byte=code_hex[byte];
//  if((weizhi==0)&&(xianshi_flag==0))
//   send_byte|=0x80;
  sendbyte(send_byte);
  c=weizhi&0x03;
  P1OUT&=~(1<<c);
}



void init_TA()
{
 
  TACCR0 = 1000;                            //8msжһ
  TACTL = TASSEL_2 + MC_1+ID_3;              // SMCLK, upmode,8Ƶ
  TACCTL0 = CCIE;                           // TACCR0 interrupt enabled
}


void shumaguan()
{
   ++t;
 if(t>=4)
   t=0;
  send_char(t,dis_play[t]); 
}




////ʱģ
#define DS1302_DIR  P1DIR
#define DS1302_IN    P1IN
#define DS1302_OUT  P1OUT

#define DS1302_RST  BIT7
#define DS1302_SCLK  BIT4
#define DS1302_SDI  BIT5  //MSP320Ķ˿

#define DS1302_RST_LO  DS1302_OUT &= ~DS1302_RST
#define DS1302_RST_HI  DS1302_OUT |= DS1302_RST
#define DS1302_SCLK_LO  DS1302_OUT &= ~DS1302_SCLK
#define DS1302_SCLK_HI  DS1302_OUT |= DS1302_SCLK
#define DS1302_SDI_LO  DS1302_OUT &= ~DS1302_SDI
#define DS1302_SDI_HI  DS1302_OUT |= DS1302_SDI


void DS1302_Reset(void);
void DS1302_WriteOneByte(unsigned char w_dat);
void DS1302_WriteData(unsigned char addr,unsigned char w_dat);
void DS1302_SettingData(void);
void DS1302_GetData(unsigned char *str);
unsigned char DS1302_ReadOneByte(void);
unsigned char DS1302_ReadData(unsigned char addr);

unsigned char Setting_Time[7]={ //bit7 bit6 bit5 bit4 bit3 bit2 bit1 bit0
 0x15,    //--------ʮλ-------|-------λ--------|(ǰ07)
 0x04,    //                        |-----λ-----|(ǰ)
 0x09,    //              |ʮλ|-------λ--------|·(ǰ07)
 0x10,    //         |--ʮλ---|-------λ--------|(ǰ01)
 0x13,    //-12H|    |--ʮλ---|-------λ--------|Сʱ(ǰ18)
 0x00,    //    |-----ʮλ-----|-------λ--------|(ǰ20)
 0x21    //    |-----ʮλ-----|-------λ--------|(ǰ30)
};
unsigned char ReadingData[7];  //,ͬSettingDataʽ

/****************************
void main(void) {
 WDTCTL = WDTPW + WDTHOLD;
 DS1302_Reset();
 //DS1302_SettingData();
 while(1){
  DS1302_GetData(ReadingData);
  _NOP();
 };
}
****************************/


//DS1302λ
void DS1302_Reset(void) {
 DS1302_DIR |=  DS1302_SCLK;
 
 DS1302_SCLK_LO;
 DS1302_RST_LO;
// delay_us(10);
 DS1302_SCLK_HI;
}

//DS1302дһֽ
void DS1302_WriteOneByte(unsigned char w_dat) {
 unsigned char temp;
 
 DS1302_RST_HI;
 DS1302_DIR |= DS1302_SDI;
 
 for(temp=8;temp>0;temp--) {
  DS1302_SDI_LO;
  if(w_dat&BIT0) DS1302_SDI_HI;
  DS1302_SCLK_LO;
//  delay_us(10);
  DS1302_SCLK_HI;
//  delay_us(10);
  w_dat >>=1;
 } 
}

//DS1302жȡһֽ
unsigned char DS1302_ReadOneByte(void) { 
 unsigned char temp,rdata;
 rdata = 0x00;
 
 DS1302_RST_HI;
 DS1302_DIR &= ~DS1302_SDI;
 
 for(temp=0;temp<8;temp++){rdata >>= 1;//λŵǰ棬һλ
  DS1302_SCLK_HI;
// delay_us(10);
  DS1302_SCLK_LO;
//  delay_us(10);
  if((DS1302_IN&DS1302_SDI)==DS1302_SDI)
   rdata |= BIT7;
  //rdata >>= 1;
 }
 
 return(rdata); 
}

//DS1302дַд
void DS1302_WriteData(unsigned char addr,unsigned char w_dat) {
 DS1302_RST_LO;
 DS1302_SCLK_LO;
 DS1302_RST_HI;
 
 DS1302_WriteOneByte(addr);  //дַ
 DS1302_WriteOneByte(w_dat);  //д
 
 DS1302_SCLK_HI;
 DS1302_RST_LO;
} 

//DS1302дַ,DS1302жȡ
unsigned char DS1302_ReadData(unsigned char addr) {
 unsigned char r_dat;
 DS1302_RST_LO;
 DS1302_SCLK_LO;
 DS1302_RST_HI;
 
 DS1302_WriteOneByte(addr);  //дַ
 r_dat = DS1302_ReadOneByte();  //
 
 DS1302_SCLK_LO;
 DS1302_RST_LO;
 
 return(r_dat);
}

//SettingDataDS1302ʱ
void DS1302_SettingData(void) {
 unsigned char temp;
 unsigned char addr = 0x8C;
 
 DS1302_WriteData(0x8E,0x00);  //д,д

 for(temp=0;temp<7;temp++) {
  DS1302_WriteData(addr,Setting_Time[temp]);
  addr -= 2;
 }
 
 DS1302_WriteData(0x8E,0x80);  //д,д
}

//ȡDS1302ʱ䵽ReadingData
void DS1302_GetData(unsigned char *str) {
 unsigned char temp;
 unsigned char addr = 0x8D;

 for(temp=0;temp<7;temp++) {
  str[temp] = DS1302_ReadData(addr);//
  addr -= 2;
 }
}

void shumaguan_buff(void)
{
  if(++t3==30)
  t3=0;
  if(t3<5)t2=1;
  else if(t3<10)t2=2;
  else if(t3<20)t2=3;
  else t2=4;
  switch(t2)
  {
  case 1:dis_play[0]=2;dis_play[1]=0;dis_play[2]=ReadingData[0]/16;dis_play[3]=ReadingData[0]%16;break;                                       //ʾ
  case 2:dis_play[0]=ReadingData[2]/16;dis_play[1]=ReadingData[2]%16;dis_play[2]=ReadingData[3]/16;dis_play[3]=ReadingData[3]%16;break;       //ʾ·
  case 3:dis_play[0]=ReadingData[4]/16;dis_play[1]=ReadingData[4]%16;dis_play[2]=ReadingData[5]/16;dis_play[3]=ReadingData[5]%16;break;       //ʾʱ
  case 4:dis_play[0]=ReadingData[1]%16;dis_play[1]=14;dis_play[2]=ReadingData[6]/16;dis_play[3]=ReadingData[6]%16;break;                      //ʾ
  default:break;
  }
  
}

 
#pragma vector=TIMER0_A0_VECTOR  
__interrupt void TIMERA0_ISR() // the interrupt source is CC0
{
  ++t1;
  if(t1>=125)
    t1=0;
  if(t1==0)
  {
    DS1302_GetData(ReadingData);
    shumaguan_buff();
  }  
else
 shumaguan();
}


